config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :tenants
  resources :users

  resources :properties
  get 'advertised', to: 'properties#advertised_properties'

  resources :landlords

  resources :tenancies
  get 'due_this_month', to: 'tenancies#due_this_month'

  controller :sessions do
    get 'login' => :new, as: :login
    post 'login' => :create
    delete 'logout' => :destroy, as: :logout
  end

  root 'sessions#new'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/tenancy.rb
# frozen_string_literal: true

class Tenancy < ApplicationRecord

  validates :property, presence: true
  validates :start_date, presence: true
  validates :security_deposit, numericality: { greater_than: 0.0}, presence: true
  validates :monthly_rent, numericality: { greater_than: 0.0}, presence: true
  validate :validate_tenants

  belongs_to :property, inverse_of: :tenancy

  has_many :tenancies_tenants
  has_many :tenants, through: :tenancies_tenants, dependent: :destroy

  scope :due_this_month, -> {where("cast(strftime('%m', start_date) as int) = ?", Date.today.month)}

  def validate_tenants
    errors.add(:tenants, "Pick at least one tenant") if tenants.size < 1
  end
end

app/controllers/tenancies_controller.rb
# frozen_string_literal: true

class TenanciesController < ApplicationController
  before_action :set_tenancy, only: %i[show edit update destroy]

  def index
    @tenancies = Tenancy.all
  end

  def due_this_month
    @tenancies = Tenancy.all.due_this_month
  end

  def show; end

  def new
    @tenancy = Tenancy.new
    if params[:property_id]
      @tenancy.property_id = params[:property_id]
    end
  end

  def edit; end

  def create
    @tenancy = Tenancy.create(tenancy_params)
    if @tenancy.persisted?
      flash[:success] = 'Tenancy was successfully created.'
      redirect_to @tenancy
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @tenancy.update(tenancy_params)
      flash[:success] = 'Tenancy was successfully updated.'
      redirect_to @tenancy
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @tenancy.destroy

    redirect_to tenancies_url, notice: 'Tenancy was successfully destroyed.'
  end

  private

  def set_tenancy
    @tenancy = Tenancy.find(params[:id])
  end

  def tenancy_params
    params.require(:tenancy).permit(
      :property_id,
      :start_date,
      :security_deposit,
      :monthly_rent,
      tenant_ids: []
    )
  end
end

app/views/tenancies/_form.html.erb
<%= form_with(model: tenancy, local: true) do |form| %>
  <div class="field">
    <div class="field">
      <%= form.label 'Pick Property' %>
      <br/>
      <% property_options = Property.not_rented.collect{ |u| [u.property_name, u.id] } %>

      <% if tenancy.persisted? %>
        <% property_options = Property.all.collect{ |u| [u.property_name, u.id] } %>
      <% end %>

      <%= form.select :property_id, options_for_select(property_options,
          { selected: tenancy.property_id }),{prompt: "Please select"}, {size: 5, disabled: tenancy.persisted? }%>

      <% if tenancy.errors %>
        <% tenancy.errors[:property].each do |message| %>
          <p class="errorMessage">
            <%= message %>
          </p>
        <% end %>
      <% end %>
    </div>

    <div class="field">
    Can't find the property you're looking for?
    <%= link_to 'Add it'.html_safe, new_property_path %>
  </div>

    <div class="field">
    <%= form.label 'Pick tenants(s)' %>
    <br/>
    <%= form.select :tenant_ids, options_for_select(Tenant.all.collect{ |u| ["#{u.first_name+" "+u.last_name}", u.id] },
      { selected: tenancy.tenant_ids }),{prompt: "Please select"}, {multiple: true, size: 5}%>

    <% if tenancy.errors %>
      <% tenancy.errors[:tenants].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    Can't find the tenant you're looking for?
    <%= link_to 'Add them'.html_safe, new_tenant_path %>
  </div>

    <%= form.label :start_date %>
    <%= form.date_field :start_date, disabled: tenancy.persisted?, min: Date.today, max: (Date.today+1.year) %>

    <% if tenancy.errors[:start_date] %>
      <% tenancy.errors[:start_date].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label :security_deposit %>

    <%= form.number_field :security_deposit, min: 0.0, step: :any %>

    <% if tenancy.errors[:security_deposit] %>
      <% tenancy.errors[:security_deposit].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label :monthly_rent %>

    <%= form.number_field :monthly_rent, min: 0.0, step: :any %>

    <% if tenancy.errors[:monthly_rent] %>
      <% tenancy.errors[:monthly_rent].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="actions">
    <% if tenancy.persisted? %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Update Tenancy
      </button>

      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, tenancy, class: "destroyButton" %>
    <% else %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Create Tenancy
      </button>
      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, tenancies_path, class: "destroyButton" %>
    <% end %>
  </div>
<% end %>

app/views/tenancies/due_this_month.html.erb
<section class='scaffold'>
   <h2>Rent due in <%=  Date.today.strftime("%B") %></h2>
   <% if @tenancies.any? %>
      <table class="scaffoldListTable">
        <thead>
        <tr>
          <th>Property Name</th>
          <th>Rent Due</th>
          <th>Date</th>
        <tr>
        </thead>
        <tbody>
          <% @tenancies.each do |tenancy| %>
            </tr>
              <td><%= tenancy.property.property_name %></td>
              <td><%= tenancy.monthly_rent %></td>
              <td><%= tenancy.start_date.strftime("%d %b") %></td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% else %>
    No rent due this month.
  <% end %>
</section>

app/views/tenancies/edit.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Tenancies", tenancies_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= link_to @tenancy.property.property_name, @tenancy %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    Edit
  </h2>

    <%= render "form", tenancy: @tenancy %>
</section>

app/views/tenancies/index.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">Tenancies</h2>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Tenancy'.html_safe, new_tenancy_path, class: "addButton" %>
  </p>

  <table class="scaffoldListTable">
    <thead>
      <tr>
        <th>Property name</th>
        <th>Monthly rent</th>
        <th>Security deposit</th>
        <th>Landlords</th>
        <th>Tenants</th>
        <th>Start Date</th>
        <th colspan="3">Actions</th>
      </tr>
    </thead>

    <tbody>
      <% @tenancies.each do |tenancy| %>
        <tr>
          <td><%= link_to tenancy.property.property_name, tenancy.property %></td>

          <td><%= tenancy.monthly_rent %></td>

          <td><%= tenancy.security_deposit %></td>

          <td>
            <% tenancy.property.landlords.each do |landlord| %>
              <li><%= link_to "#{landlord.first_name+" "+landlord.last_name+", "+landlord.email}", landlord %></li>
            <% end %>
          </td>

          <td>
            <% tenancy.tenants.each do |tenant| %>
              <li><%= link_to "#{tenant.first_name+" "+tenant.last_name+", "+tenant.email}", tenant %></li>
            <% end %>
          </td>

          <td><%= tenancy.start_date %></td>

          <td><%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>'.html_safe, edit_tenancy_path(tenancy), title: "" %></td>

          <td><%= link_to '<i class="fa fa-eye"></i>'.html_safe, tenancy, title: "" %></td>

          <td><%= link_to '<i class="fa fa-trash" aria-hidden="true"></i>'.html_safe, tenancy,
          method: :delete, data: { confirm: "Are you sure want to delete this tenancy?" } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Tenancy'.html_safe, new_tenancy_path, class: "addButton" %>
  </p>
</section>

app/views/tenancies/new.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Landlords", tenancies_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    New Tenancy
  </h2>

    <%= render "form", tenancy: @tenancy %>
</section>

app/views/tenancies/show.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Tenancies", tenancies_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= @tenancy.property.property_name %>
  </h2>
  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Tenancy'.html_safe, new_tenancy_path, class: "addButton" %>
  </p>

  <table class="scaffoldDataTable">
    <tbody>
      <tr>
        <th>Property Name</th>

        <th>Security Deposit</th>

        <th>Monthly Rent</th>

        <th>Start Date</th>
      </tr>

      <tr>
        <td><%= @tenancy.property.property_name %></td>

        <td><%= @tenancy.security_deposit %></td>

        <td><%= @tenancy.monthly_rent %></td>

        <td><%= @tenancy.start_date %></td>
      </tr>


      <tr>
        <th>Landlords</th>
      </tr>

      <% @tenancy.property.landlords.each do |landlord| %>
        <tr>
          <td><%= link_to "#{landlord.first_name+" "+landlord.last_name}", landlord %></td>
        </tr>
      <% end %>

      <tr>
        <th>Tenants</th>
      </tr>

      <% @tenancy.tenants.each do |tenant| %>
        <tr>
          <td><%= link_to "#{tenant.first_name+" "+tenant.last_name}", tenant %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <p>
    <%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>Edit Tenancy'.html_safe, edit_tenancy_path(@tenancy), class: "defaultButton" %>
  </p>
</section>